SET SERVEROUTPUT ON;
spool proves.log
set echo on

/*******************************************************************************************
    PROVES ABM 
*******************************************************************************************/

-- CENTRAL_PRODUCCIO --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta amb localitat que no existeix (ERR_NO_LOC)
  pkg_abm.prc_alta_central_produccio (
      p_idtipusprod    => 1,
      p_direccio       => 'C\ Torrevieja, 2',
      p_idlocalitat    => 20,
      p_data_it        => TO_DATE('20/04/2010'),
      p_atribut_1      => 100,
      p_atribut_2      => 100,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta amb tipus sense informar (ERR_NULL)
  pkg_abm.prc_alta_central_produccio (
      p_idtipusprod    => NULL,
      p_direccio       => 'C\ Torrevieja, 2',
      p_idlocalitat    => 6,
      p_data_it        => TO_DATE('20/04/2010'),
      p_atribut_1      => 100,
      p_atribut_2      => 100,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta amb tipus erroni (ERR_NO_TIPUS)
  pkg_abm.prc_alta_central_produccio (
      p_idtipusprod    => 10,
      p_direccio       => 'C\ Torrevieja, 2',
      p_idlocalitat    => 6,
      p_data_it        => TO_DATE('20/04/2010'),
      p_atribut_1      => 100,
      p_atribut_2      => 100,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Baixa de central de producci
  pkg_abm.prc_baixa_central_produccio (
      p_idcentralprod  => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  -- Modificaci de direcci de central de producci
  pkg_abm.prc_modif_central_produccio (
      p_idcentralprod  => 2,
      p_idtipusprod    => NULL,
      p_direccio       => 'C\ Pursiana, 22',
      p_idlocalitat    => NULL,
      p_data_it        => NULL,
      p_atribut_1      => NULL,
      p_atribut_2      => NULL,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Reactivacio de central de producci
  pkg_abm.prc_react_central_produccio (
      p_idcentralprod  => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- CENTRAL_DISTRIBUCIO --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta amb lnia de comunicaci que no existeix (ERR_NO_LINIA)
  pkg_abm.prc_alta_central_distribucio (
      p_idlinia        => 24,
      p_direccio       => 'C\ Montserrat n 47',
      p_idlocalitat    => 1,
      p_energia_max    => 500,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Baixa de central de distribuci
  pkg_abm.prc_baixa_central_distribucio (
      p_idcentraldis   => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  -- Modificaci de lnia de comunicaci de central de producci
  pkg_abm.prc_modif_central_distribucio (
      p_idcentraldis   => 2,
      p_idlinia        => 9,
      p_direccio       => NULL,
      p_idlocalitat    => NULL,
      p_energia_max    => NULL,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Reactivacio d'una central de distribuci que no est donada de baixa (ERR_DIS_ALTA)
  pkg_abm.prc_react_central_distribucio (
      p_idcentraldis   => 2,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- COMPTADOR --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta amb NIF que no existeix (ERR_NO_CLIENT)
  pkg_abm.prc_alta_comptador (
      p_nif            => '99999999Z',
      p_potencia       => 10,
      p_direccio       => 'C\ Tejada, n 21',
      p_idlocalitat    => 1,
      p_idmodel        => 2,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Baixa d'un comptador que no existeix (ERR_NO_IDCONTRACTE)
  pkg_abm.prc_baixa_comptador (
      p_idcontracte    => 40,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Canvi de client al comptador
  pkg_abm.prc_modif_comptador (
      p_idcontracte    => 2,
      p_nif            => '11427378Y',
      p_potencia       => NULL,
      p_direccio       => NULL,
      p_idlocalitat    => NULL,
      p_idmodel        => NULL,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- LINIA_COMUNICACIO --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta lnia de comunicaci amb central de producci inexistent (ERR_NO_IDCENTPROD)
  pkg_abm.prc_alta_linia_comunicacio (
      p_idcentralprod  => 40,
      p_capacitat_max  => 400,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Baixa d'una linia que no existeix (ERR_NO_IDLINIA)
  pkg_abm.prc_baixa_linia_comunicacio (
      p_idlinia        => 40,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Canvi de capacitat a la lnia de comunicaci
  pkg_abm.prc_modif_linia_comunicacio (
      p_idlinia        => 16,
      p_idcentralprod  => NULL,
      p_capacitat_max  => 600,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- CLIENT --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de client d'un nif que ja existeix (ERR_NIF)
  pkg_abm.prc_alta_client (
      p_nif            => '11111111A',
      p_tipusclient    => 1,
      p_nom            => 'Roberto',
      p_cognom1        => 'Torres',
      p_cognom2        => 'Ramrez',
      p_data_naixement => TO_DATE('06/03/1964'),
      p_direccio       => 'C\ Oliver, 13',
      p_idlocalitat    => 6,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de client sense nom (ERR_NULL)
  pkg_abm.prc_alta_client (
      p_nif            => '13732597H',
      p_tipusclient    => 1,
      p_nom            => NULL,
      p_cognom1        => NULL,
      p_cognom2        => NULL,
      p_data_naixement => TO_DATE('06/03/1964'),
      p_direccio       => 'C\ Oliver, 13',
      p_idlocalitat    => 6,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de client
  pkg_abm.prc_alta_client (
      p_nif            => '13732597H',
      p_tipusclient    => 1,
      p_nom            => 'Roberto',
      p_cognom1        => 'Torres',
      p_cognom2        => 'Ramrez',
      p_data_naixement => TO_DATE('06/03/1964'),
      p_direccio       => 'C\ Oliver, 13',
      p_idlocalitat    => 6,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Baixa de client
  pkg_abm.prc_baixa_client (
      p_nif            => '23436279X',
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Modificaci nom de client
  pkg_abm.prc_modif_client (
      p_nif            => '23436279X',
      p_tipusclient    => NULL,
      p_nom            => 'Fernando',
      p_cognom1        => NULL,
      p_cognom2        => NULL,
      p_data_naixement => NULL,
      p_direccio       => NULL,
      p_idlocalitat    => NULL,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- POBLACIO --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de poblaci en un pais que no existeix (ERR_NO_PAIS)
  pkg_abm.prc_alta_poblacio (
      p_nompoblacio    => 'Toledo',
      p_idpais         => 50,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de nova poblaci amb un nom que ja existeix (ERR_NOMPOBLACIO)
  pkg_abm.prc_alta_poblacio (
      p_nompoblacio    => 'Palma de Mallorca',
      p_idpais         => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de nova poblaci
  pkg_abm.prc_alta_poblacio (
      p_nompoblacio    => 'Manacor',
      p_idpais         => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Modificaci de pas en poblaci
  pkg_abm.prc_modif_poblacio (
      p_idpoblacio     => 8,
      p_nompoblacio    => NULL,
      p_idpais         => 2,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Eliminaci de poblaci que est vinculada a una localitat (ERR_IDPOB_LOCALITAT)
  pkg_abm.prc_borra_poblacio (
      p_idpoblacio     => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Eliminaci de poblaci sense localitat vinculada
  pkg_abm.prc_borra_poblacio (
      p_idpoblacio     => 8,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

-- LOCALITAT --
DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de localitat amb un codi postal que ja existeix (ERR_CODPOSTAL)
  pkg_abm.prc_alta_localitat (
      p_nomlocalitat   => 'Son Gotleu', 
      p_idpoblacio     => 1,
      p_codpostal      => 07008,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de localitat amb una poblaci que no existeix (ERR_NO_POBLACIO)
  pkg_abm.prc_alta_localitat (
      p_nomlocalitat   => 'Son Roca', 
      p_idpoblacio     => 30,
      p_codpostal      => 07027,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Alta de nova localitat
  pkg_abm.prc_alta_localitat (
      p_nomlocalitat   => 'Son Roca', 
      p_idpoblacio     => 1,
      p_codpostal      => 07027,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Modificaci de la poblaci de la localitat
  pkg_abm.prc_modif_localitat (
      p_idlocalitat    => 7,
      p_nomlocalitat   => NULL, 
      p_idpoblacio     => 2,
      p_codpostal      => NULL,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Eliminaci de localitat que est vinculada a una
  --central de producci (ERR_IDLOC_CENTRALPROD)
  pkg_abm.prc_borra_localitat (
      p_idlocalitat    => 1,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

DECLARE
  resultat VARCHAR2(2000);
BEGIN
  --Eliminaci de localitat sense localitat vinculada
  pkg_abm.prc_borra_localitat (
      p_idlocalitat    => 8,
      rsp              => resultat
  );
  dbms_output.put_line(resultat);
END;
/

set linesize 200
set heading on

/*******************************************************************************************
    PROCEDIMENTS DE CONSULTA
*******************************************************************************************/

/******************** Llista comptadors consum mensual > 80% mitja ************************/
SET LINESIZE 250
SET PAGESIZE 30
COL IDCONTRACTE FORMAT 999
COL POTENCIAMAX FORMAT 999999
COL PERC_CONSUM FORMAT 999.99
SELECT * FROM TABLE(f_consum_superior_80('Arenal', '10/08/2011'));

/**************** Llista 10 centraletes que distribueixen ms energia *********************/
SET LINESIZE 250
SET PAGESIZE 30
COL DIRECCIO FORMAT A50
COL ENERGIA_EMESA FORMAT 999999
COL ENERGIA_MAX FORMAT 999999
SELECT * FROM TABLE(f_energia_central_distribucio());

/************ Llista 10 linies de comunicaci amb mes percentatge de crrega **************/
SET LINESIZE 250
SET PAGESIZE 30
COL IDLINIA FORMAT 999
COL CARREGA FORMAT 99999.99
COL ENERGIA_PERMESA FORMAT 999999
SELECT * FROM TABLE(f_carrega_linia_comunicacio());

/**************** Llista clients amb contadors en alta disponibilitat *********************/
SET LINESIZE 250
SET PAGESIZE 30
COL NIF FORMAT A12
COL IDCONTRACTE FORMAT 999
COL NOMMODEL FORMAT A30
SELECT * FROM TABLE(f_clients_compt_disponibilitat());

/******************** Llista consum comptadors de central producci ***********************/
SET LINESIZE 250
SET PAGESIZE 30
COL NIF FORMAT 999
COL IDCONTRACTE FORMAT 99999
COL NOMMODEL FORMAT 999999
SELECT * FROM TABLE(f_consum_produccio(1, '01/10/2011', '31/10/2011'));

/******************* Percentatge de lectures en un periode de temps ***********************/
SET LINESIZE 250
SET PAGESIZE 30
COL PERC_TELEMATICA FORMAT 999.99
COL PERC_PRESENCIAL FORMAT 999.99
SELECT * FROM TABLE(f_perc_lectura('01/03/2012', '31/03/2012'));

/************************** Anys d'antiguitat dels comptadors *****************************/
-- primer modificarem la data d'alta d'un comptador per fer la prova
-- ja que la data d'alta se carrega automticament
UPDATE COMPTADOR
   SET DATA_ALTA = '01/01/2009'
 WHERE IDCONTRACTE = 18;
COMMIT;
--
SET LINESIZE 250
SET PAGESIZE 30
COL IDCONTRACTE FORMAT 999
COL DATA_ALTA FORMAT A10
SELECT * FROM TABLE(f_antiguitat_comptadors(3));

/*******************************************************************************************
    MDUL ESTADSTIC
*******************************************************************************************/

/*********************************** estadstic 1 *****************************************/
-- Consum total dels comptadors que depenen duna central de producci concreta.
--
select idcentralprod, consum_total 
from est_consumcomptprod
where idcentralprod = 1;

/*********************************** estadstic 2 *****************************************/
-- Valor mitj de lenergia consumida per una lnia de comunicaci en un any concret.
select idlinia, p_any, mitja_consum
from EST_CONSUMLINIAANY
where idlinia = 4
  and p_any = 2011;
  
/*********************************** estadstic 3 *****************************************/
-- Lnia ms carregada a nivell denergia consumida.
select idlinia, perc_carrega 
from EST_LINIAMESCARREGADA;

/*********************************** estadstic 4 *****************************************/
-- Percentatge de lnies que superen el 50% denergia consumida en un any concret.
select p_any, perc_linies 
from est_anyliniesenconsum
where p_any = 2011;

/*********************************** estadstic 5 *****************************************/
-- Nombre de centrals de producci que generen menys dun 30% de producci en un any concret.
select p_any, total
from est_sumacpany
where p_any = 2011;

/*********************************** estadstic 6 *****************************************/
-- 10 comptadors que han tingut histricament ms consum. (ordenades de major a menor consum)
select idcontracte, consum_total 
from est_top10comptadors
order by consum_total desc;

/*********************************** estadstic 7 *****************************************/
-- Consum mig de tots els clients.
select consum_mig
from est_consummigclients;

/******************************* Consulta del fitxer LOGS *********************************/
SET LINESIZE 250
SET PAGESIZE 400
COL IDLOG FORMAT 999
COL NOMPROC FORMAT A50
COL LOGDATE FORMAT A10
COL PARIN FORMAT A80
COL PAROUT FORMAT A80

SELECT * FROM LOGS
ORDER BY 1;

SET SERVEROUTPUT OFF

set echo off

spool off
exit